import Resonator from '../framework/resonator';


export default class Sound {
    constructor() {
        this.res = new Resonator();
        this.ambience = null;
        this.music = null;
        this.previousAmbience = null;
        this.previousMusic = null;
    }

    play(file) {
        const sound = this.res.loadImmediate(file);
        sound.play();
    }

    async setAmbience(file) {
        if (this.ambience) {
            this.previousAmbience = this.ambience;
            this.ambience = null;
            setTimeout(() => this.previousAmbience.fadeOut(6), 1500);
            // setTimeout(() => this.previousAmbience.destroy(), 6000);
        }
        if (!file) return;
        this.ambience = this.res.stream(file, 0);
        this.ambience.play();
        this.ambience.loop(true);
        this.ambience.fadeIn(3);
    }

    setMusic(file) {
        if (this.music) {
            this.previousMusic = this.music;
            setTimeout(() => this.previousMusic.fadeOut(2), 500);
            setTimeout(() => this.previousMusic.destroy(), 2000);
        }
        if (!file) return;
        this.music = this.res.stream(file, 1);
        this.music.play();
        this.music.fadeIn(2);
    }

    setImpulse(file) {
        this.res.setEnvironmentImpulse(file);
    }
}